unit DJ_Cam;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, Forms, sysutils, Controls, StdCtrls, ExtCtrls, ComCtrls,


  videodev2{, gtk2, gdk2, gdk2x, glib};

type
  Av_capability                        = array of v4l2_capability;
  { TForm3 }

  TForm3                               = class(TForm)
    procedure FormCreate(Sender : TObject);
    procedure FormShow(Sender : TObject);
  private
    // Copy of VideoTestDemo;
    AAv_capability                     : Av_capability;
    TSLInterfacesList                  : TStringList;

    FHandle, FWidth, FHeight,
    CurrentVideoFormat                 : Integer;


    Cam_List                           : TListBox;
    Cam_Tab                            : TPageControl;
    Cam_Setting                        : array [0..2] of TScrollBox;
    Cam_SetUp                          : array [0..2] of TTabsheet;

  public

  end;

var
  Form3                                : TForm3;
  i                                    : byte;

implementation

uses
  BaseUnix;

{$R *.lfm}

{ TForm3 }

procedure TForm3.FormCreate(Sender : TObject);
begin
  // ---> Eventuelle Formdefinitionen !!!
  TSLInterfacesList                    := TStringList.Create();
  Cam_List                             := TListBox.Create(NIL);
  with cam_list do begin
    Align                              := alClient;
    Parent                             := Form3;
  end;
  Cam_Tab                              := TPageControl.Create(NIL);
  with Cam_Tab do begin
    Align                              := alClient;
    Parent                             := Form3;
    Visible                            := False;
  end;

  for i := 0 to 2 do begin
    Cam_SetUp[i]                       := TTabSheet.Create(NIL);
    with Cam_SetUp[i] do begin
      Align                            := alClient;
      Enabled                          := false;
      Parent                           := Cam_Tab;
    end;
    Cam_Setting[i]                     := TScrollBox.Create(NIL);
    with Cam_Setting[i] do begin
      Align                            := alClient;
      Parent                           := Cam_SetUp[i]
    end;
  end;
end;

procedure TForm3.FormShow(Sender : TObject);
var
  Rv4l2_capability: v4l2_capability;
  I: Integer;
begin
  SetLength(AAv_capability, 0);
  for I:= 0 to 99 do begin
    if FileExists('/dev/video'+ IntToStr(I)) then begin
      FHandle:= FpOpen(PChar('/dev/video'+ IntToStr(I)), O_RDONLY);
      if FpIOCtl(FHandle, VIDIOC_QUERYCAP, @Rv4l2_capability)= 0 then begin
        SetLength(AAv_capability, Length(AAv_capability)+ 1);
        AAv_capability[Length(AAv_capability)- 1]:= Rv4l2_capability;
        Cam_List.Items.Append(StrPas(@Rv4l2_capability.card)); {todo 5.11.10.23 ListBox}
        TSLInterfacesList.Append('/dev/video'+ IntToStr(I));
      end;
      FpClose(FHandle);
    end;
  end;
end;

end.

