unit Settings;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  StdCtrls,

  {User-Units}
  set_data;

type

  { TForm2 }

  TForm2 = class(TForm)
    ColorButton1: TColorButton;
    ColorButton2: TColorButton;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;

    Button1: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;

    procedure FormCreate(Sender: TObject);

    procedure BoxControl(Sender: TObject);

  private
    Set_Control              : TPageControl;

    Set_Sheet                : array [1..2] of TTabSheet;
    Box                      : array [1..2] of TCheckBox;
    P_Color                  : array [1..2] of TColorButton;

    Actions                  : array [1..3] of TButton;
    TextLabel                : array [1..3] of TLabel;

//    PConst                   : TPConst;

  public
    OBS                      : TVeeJee_OBS;
  end;

var
  Form2: TForm2;

implementation

uses main;

{$R *.lfm}

{ TForm2 }

procedure TForm2.BoxControl(Sender: TObject);
begin
  if Box[1].Checked then
    with OBS do begin
      Form1.Color            := OBS.BG_Color;
      Form1.Color            := OBS.T_Color;
      end;
  if Box[2].Checked then
    with OBS do begin
      Form2.Color            := OBS.BG_Color;
      Form2.Color            := OBS.T_Color;
      end;
end;

procedure TForm2.FormCreate(Sender: TObject);
var i: byte;
begin
// Erzeugen der Komponenten
  OBS                        := TVeeJee_OBS.Create;
  Set_Control                := TPageControl.Create(NIL);
  for i := 1 to 2 do begin
    Box[i]                   := TCheckBox.Create(NIL);
    P_Color[i]               := TColorButton.Create(NIL);
    Set_Sheet[i]             := TTabSheet.Create(NIL);

  end;

  for i := 1 to 3 do begin
    Actions[i]               := TButton.Create(NIL);
    TextLabel[i]             := TLabel.Create(NIL);

  end;

  with Form2 do begin
    Height                   := 350;
    Left                     := 600;
    Top                      := 150;
    Width                    := 400;
  end;

  // Zeichnen und definieren der Komponenten
  with Set_Sheet[1] do begin
    Caption                  := '&Color-Settings';
    with TextLabel[1] do begin
      Alignment              := taCenter;
      AutoSize               := False;
      Caption                := 'Farb~ und Schriftart Einstellung';
      Height                 := 20;
      Left                   := 10;
      Parent                 := Set_Sheet[1];
      Top                    := 10;
      Width                  := 370;
    end;
{    with TextLabel[2] do begin
      Alignment              := taCenter;
      AutoSize               := False;
      Caption                := 'Hintergrundfarbe';
      Height                 := 20;
      Left                   := 10;
      Parent                 := Set_Sheet[1];
      Top                    := 40;
      Width                  := 380;
    end;                }

    with P_Color[1] do begin
      Caption                := 'Hintergrundfarbe';
      Height                 := 40;
      Left                   := 10;
      Parent                 := Set_Sheet[1];
      Top                    := 40;
      Width                  := 370;
    end;
    with P_Color[2] do begin
      Caption                := 'Schriftfarbe';
      Height                 := 40;
      Left                   := 10;
      Parent                 := Set_Sheet[1];
      Top                    := 90;
      Width                  := 370;
    end;
    Parent                   := Set_Control;
  end;

  with Set_Control do begin
    Align                    := alTop;
    Parent                   := Form2;
  end;

//  with Box do begin
//    Heigth                   :=  22;
//    Left                     :=  10;
//    Top                      := 280;
//    Width                    := 300;

//  end;

end;

end.

